﻿Type=Class
Version=2.2
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	
	Private mTableView As TableView
	Private TableData As List
	Private mTableViewUtils As TableViewUtils
	Private mLastClickedY,mLastReleasedY As Int
	Private CurrentCell As JavaObject
	Private TransferMode As JavaObject
	Private ScrollTimer As Timer
	Private ScrollDelay As Int = 250
	Private mTarget As Object
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(Target As Object,TV As TableView)

	mTableView = TV
	mTableViewUtils.Initialize(mTableView)
	
	Dim TVJO As JavaObject = TV
	Dim FXCollections As JavaObject
	FXCollections.InitializeStatic("javafx.collections.FXCollections")
	
	'Create an Observable Array List and populate it with the columns in the table
	Dim ColumnList As JavaObject = FXCollections.RunMethod("observableArrayList",Array(TVJO.RunMethod("getColumns",Null)))
	
	'Link a CellFactory to our list
	Dim CFH As TVCellFactoryHelper
	CFH.Initialize(CFH.TYPEGRAPHIC,"Col1",ColumnList.RunMethod("get",Array(0)))
	
	TransferMode.InitializeStatic("javafx.scene.input.TransferMode")

	'Setting clipboard string causes en error first time, so just do a dummy set for now.  Need to investigate and maybe report as a bug
	fx.Clipboard.SetString("")
	
	ScrollTimer.Initialize("ScrollTimer",ScrollDelay)

End Sub
'Set the data for the list view
Sub setData(Data As List)
	TableData = Data
	SetupTableViewCF

End Sub
'initialize the listview with cellfactory objects
Sub SetupTableViewCF

	mTableView.Items.Clear

	For i = 0 To TableData.Size - 1
	
		Dim Row(3) As Object
		Dim RowData() As Object = TableData.Get(i)
		'Add a cellfactoryobject for Column1 for each row in the array
		Dim CFO As CellFactoryObject
		CFO.Initialize
		Row(0) = CFO
		'These Columns will not be managed be the CellFactory and we can pass their content directly
		Row(1) = RowData(1)
		Row(2) = RowData(2)
		mTableView.Items.Add(Row)
	Next
End Sub
#Region Data Access Subs 
Sub getRowData(Index As Int) As Object()
	Return TableData.Get(Index)
End Sub
#End Region Data Access Subs

#Region CellFactory Subs	'########################################################################################################################################

'This sub is used by the cell factory to get the pane to display, You can add UI controls to the AnchorPane.
'The cell is also exposed making it possible to style the cell using CSS inline, or add a style sheet to the cell with JavaObject
'The Id is the one provided in the Helper Initialization, you can make changes based on the ID, or even create a completely different layout for several different lists.
'If the ListViewHelper has a type TYPETEXT, this sub will not be called.
Sub getGraphic(Id As String,Column As Object) As Object			'Ignore

	#Region Required Code
	'If Required - Convert the Cell related to this Object to a JavaObject
	
	CurrentCell = Sender
	'Instantiate the Pane or Node to be returned
	Dim P As AnchorPane
	P.Initialize("")
	#End Region Required Code

	'User Code - Create a panel to be returned for display in the ListView cell

	Dim RowData() As Object = TableData.Get(CellUtilsStatic.RowIndex(CurrentCell))
	Dim ColData() As Object = RowData(0)

	Dim TF1 As TextField
	TF1.Initialize("TF1")
	P.AddNode(TF1,0,0,60,25)
	TF1.Text = ColData(Main.Col1Text)
	TF1.Id = CellUtilsStatic.RowIndex(CurrentCell)
	
	Dim Btn1 As Button
	Btn1.Initialize("Btn1")
	P.AddNode(Btn1,60,0,60,15)
	Btn1.Text = ColData(Main.Col1Text)
	
	Btn1.Visible = Main.ShowButtons
	
	
	'Dim DD As TVDragDrop
	Dim mRow As JavaObject = CellUtilsStatic.RowObject(CurrentCell)
	'DD.Initialize(Me,mRow)
	
	'Add  Mouse listener to the Row
	Dim O As Object = mRow.CreateEvent("javafx.event.EventHandler","RowMousePressed",Null)
	mRow.RunMethod("setOnMousePressed",Array(O))
	
	Dim O As Object = mRow.CreateEvent("javafx.event.EventHandler","RowDragDetected",Null)
	mRow.RunMethod("setOnDragDetected",Array(O))
	
	Dim O As Object = mRow.CreateEvent("javafx.event.EventHandler","RowDragDropped",Null)
	mRow.RunMethod("setOnDragDropped",Array(O))

	Dim O As Object = mRow.CreateEvent("javafx.event.EventHandler","RowDragOver",Null)
	mRow.RunMethod("setOnDragOver",Array(O))
	
	Dim O As Object = mRow.CreateEvent("javafx.event.EventHandler","RowDragEntered",Null)
	mRow.RunMethod("setOnDragEntered",Array(O))
	
	Dim O As Object = mRow.CreateEvent("javafx.event.EventHandler","RowDragExited",Null)
	mRow.RunMethod("setOnDragExited",Array(O))
	
	Dim O As Object = mRow.CreateEvent("javafx.event.EventHandler","RowDragDone",Null)
	mRow.RunMethod("setOnDragDone",Array(O))
	#Region Required Code
	'Must Return the Pane or Node to be displayed
	Return P
	#End Region Required Code
End Sub

'This sub is used by the cell factory to get the text to display for this object, you can create a string to return from the fields available or any other code.
'The Id is the one provided in the Helper Initialization, you can make changes to the text based on the ID or use it for different Lists.
'If the ListViewHelper has a type TYPEGRAPHIC, this sub will not be called.
Sub getText(Id As String,CallingCell As Object) As String			
#Region Required Code
	Dim ReturnString As String

	'Record the Cell related to this Object once it has been displayed
	Dim Cell As JavaObject = Sender
#End Region Required Code
	
	'User Code
	
	
	'As the cells are reused as they are displayed, remove any residual styles for this cell
	Cell.RunMethod("setStyle",Array(""))
	
	'Set style on the Cell for the current object
	
	
#Region Required Code
	'Must return a String
	Return ReturnString
#End Region Required code
End Sub

#End Region Cell Factory Subs

#Region User Subs
Sub TableRowMove(SourceIndex As Int,TargetIndex As Int)
	
	'Adjust if the target is below the source as we are going to remove the source first
	If TargetIndex > SourceIndex Then TargetIndex = TargetIndex - 1
	
	'Get a copy of the source data
	'Dim TempRow() As Object = mTableView.Items.Get(SourceIndex)
'	
'	'Remove it from the table
'	mTableView.Items.RemoveAt(SourceIndex)
'	
'	'Insert it at the target location
'	mTableView.Items.InsertAt(TargetIndex,TempRow)
	
	'Do the same For out underlying data set
	Dim RowData() As Object = TableData.Get(SourceIndex)
	TableData.RemoveAt(SourceIndex)
	TableData.InsertAt(TargetIndex,RowData)
	
	SetupTableViewCF
	
	'Refresh the TableView
	mTableViewUtils.RefreshAll
	
	'Move selection to target location
	mTableView.SelectedRow = TargetIndex
	
	'Optionally clear it altogether
	'TableView1Utils.ClearSelection
	End Sub

#End Region User Subs

'Capture the Y coordinate of a button press on the cell
Private Sub RowMousePressed_Event(MethodName As String,Args() As Object)
	Dim E As MouseEvent = Args(0)
	mLastClickedY = E.Y
End Sub
Private Sub RowDragDetected_Event(MethodName As String,Args() As Object)
	Dim E As Event = Args(0)
	Dim TargetRow As JavaObject = Sender
	Dim DragBoard As JavaObject = TargetRow.RunMethod("startDragAndDrop",Array(TransferMode.GetField("ANY")))
	Dim TargetRowStr As String = CellUtilsStatic.RowIndex(TargetRow)
	Dim Content As JavaObject
	Content.InitializeNewInstance("javafx.scene.input.ClipboardContent",Null)
	Content.RunMethod("putString",Array(TargetRowStr))
	DragBoard.RunMethod("setContent",Array(Content))
	E.Consume
	
End Sub
Private Sub RowDragDropped_Event(MethodName As String,Args() As Object)
	Dim E As JavaObject = Args(0)
	Dim Row As JavaObject = Sender
	Dim DragBoard As JavaObject = E.RunMethod("getDragboard",Null)
	Dim SourceIdx As Int = DragBoard.RunMethod("getString",Null)
	Dim TargetIdx As Int = CellUtilsStatic.RowIndex(Row)
	'If the cell is dropped in the top half of the Target, move above, otherwise move below
	If E.RunMethod("getY",Null) > Row.RunMethod("getHeight",Null) / 2 Then TargetIdx = TargetIdx + 1
	E.RunMethod("setDropCompleted",Array(True))
	TableRowMove(SourceIdx,TargetIdx)
End Sub
Private Sub RowDragOver_Event(MethodName As String,Args() As Object)
	Dim Row As JavaObject = Sender
	Dim E As JavaObject = args(0)
	E.RunMethod("acceptTransferModes",Array(TransferMode.GetField("COPY_OR_MOVE")))
	E.RunMethod("consume",Null)
	
	If Not(ListViewUtils.Scrolling) Then
		' Checking for scroll required
	    Dim TV As TableView = Row.RunMethod("getTableView",Null)
		Dim TVJO As JavaObject = TV
	    Dim Skin As JavaObject  = TVJO.RunMethodJO("getSkin",Null) '  Get the skin from our TableView
		
		'Setup our flow library object
	    Dim Flow As VirtualFlow
		Flow.Initialize(Skin.RunMethodJO("getChildren",Null).RunMethodJO("get",Array As Object(1))) ' Get the virtualflow from the skin
		
		'Get positional information
	    Dim First As Int = Flow.FirstVisibleCell.RunMethod("getIndex",Null) 				' Get the first row index from the virtualflow
		Dim FirstV As Int = Flow.FirstVisibleCellWithinViewPort.RunMethod("getIndex",Null) 	' Get the first visible row index from the virtualflow
	    Dim Last As Int = Flow.LastVisibleCell.RunMethod("getIndex",Null) 					' Get the last row index from the virtual flow
		Dim LastV As Int = Flow.LastVisibleCellWithinViewPort.RunMethod("getIndex",Null) 	' Get last visible row index from the virtual flow
		Dim Current As Int = Row.RunMethod("getIndex",Null)									'Get the current row index

'		'Log Values For testing
'		Log("First: "& First & " Current:" & Current &" Last: " & Last) 					' just display values
'		Log("FirstV " & FirstV & " LastV " & LastV)
'		Log("LY " & Row.RunMethod("getLayoutY",Null))
'		Log("VH " & Flow.Height)
'		Log("Cell Height" & Row.RunMethod("getHeight",Null))
'		Log("Diff " & (Flow.Height - Row.RunMethod("getLayoutY",Null) - Row.RunMethod("getHeight",Null)))
		
		'Sometimes there can be a full cell above the header position that is reported as First, but is not visible so wee need to check
		If Current = First OR (Current = FirstV AND Row.RunMethod("getLayoutY",Null) < 5) _
		OR (Current = FirstV + 1 AND Row.RunMethod("getLayoutY",Null) < 5) Then 
			'Scroll Up
			
			Dim Move As Int = -1
			If Current <> First AND (Row.RunMethod("getLayoutY",Null) < 5) Then Move = 0
			
			'Set a lock so the scrolling can be controlled via timer
			ListViewUtils.Scrolling = True
			
			ScrollTimer.Enabled = True
			Dim Pos As Int = Min(First,FirstV) + Move
			Flow.Show(Max(0,Pos))
		End If
		
		'Sometimes there can be a full cell above the Horizontal Scrollbar position that is reported as Last, but is not really visible so wee need to check
		If Current = Last OR Current = LastV AND Flow.Height - Row.RunMethod("getLayoutY",Null) - Row.RunMethod("getHeight",Null) < 14 _
		OR Current = LastV - 1 AND Flow.Height - Flow.LastVisibleCellWithinViewPort.RunMethod("getLayoutY",Null) < 5 Then
			'Scroll Down
			
			Dim Move As Int = 1
			If Current <> Last AND (Flow.Height - Row.RunMethod("getLayoutY",Null) - Row.RunMethod("getHeight",Null) < 14 _
			OR Flow.Height - Flow.LastVisibleCellWithinViewPort.RunMethod("getLayoutY",Null) < 5) Then Move = 0
			
			'Set a lock so the scrolling can be controlled via timer
			ListViewUtils.Scrolling = True
			
			ScrollTimer.Enabled = True
			Dim Pos As Int = Last + Move
			Flow.Show(Pos)
		End If
	End If
End Sub
Private Sub RowDragEntered_Event(MethodName As String,Args() As Object)
	Dim TargetRow As JavaObject = Sender
	Dim TargetNode As Node = TargetRow
	TargetNode.Style = "-fx-background-color:lightgray;"
End Sub
Private Sub RowDragExited_Event(MethodName As String,Args() As Object)
	Dim TargetRow As JavaObject = Sender
	Dim TargetNode As Node = TargetRow
	TargetNode.Style = ""
End Sub
Private Sub RowDragDone_Event(MethodName As String,Args() As Object)
	Dim TargetRow As JavaObject = Sender
		
	'It would turn off automatically in timer tick, but to be sure
	ListViewUtils.Scrolling = False
	ScrollTimer.Enabled = False
End Sub

Sub getLastClickedY As Int
	Return mLastClickedY
End Sub

Sub TF1_TextChanged (Old As String, New As String)
	Dim TF As TextField = Sender
	Dim RowData() As Object = TableData.Get(TF.Id)
	Dim CellData() As Object = RowData(0)
	Dim CurrentText As String = CellData(Main.Col1Text)
	
	'Do not update if the user hasn't changed the text
	If New <> CurrentText Then
		'Update the data
		CellData(Main.Col1Text) = New
	End If
End Sub
Sub ScrollTimer_Tick
	ScrollTimer.Enabled = False
	ListViewUtils.Scrolling = False
End Sub

#Region Testing Code
Sub ShowData
	For i = 0 To TableData.Size - 1
		Dim RowData() As Object = TableData.Get(i)
		Dim CellData() As Object = RowData(0)
		Log("Row Index " & i &" contains """ & CellData(Main.Col1Text) & """")
	Next
End Sub
#End Region Testing Code